<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Controller;
use Illuminate\Pagination\Paginator;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\ClientException;
use Illuminate\Support\Facades\Auth;
use Tymon\JWTAuth\Facades\JWTAuth;


use App\Models\User;
use Illuminate\Support\Facades\View;
use App\Models\Diamond;


class DiamondController extends Controller
{
    
    public function index(Request $request)
    {
      echo "Welcome to my app.";
      
    }
    
    public function load_more_data(Request $request){
     
      $stock_id = $request->stock_id; 
      $store_name = $request->store_name;
      $page_name = $request->page_name;
      $shop = $request->shop;
      //  print_r('hello'); die;

        if(!empty($stock_id) && $page_name == 'diamond-details'){
          $diamond_query = "select * from tbl_diamond where stock_id = '$stock_id'  limit 1";
          $diamond_record = DB::select($diamond_query);
          echo json_encode(array(
            'records'=>$diamond_record,
            'page_name' => $page_name
          ));
        }else{
          
          // $theme_json = json_decode($user_data[0]->theme_json);

          $page=$request->page ?? 1;
          $per_page=$request->per_page ?? 50;

          $is_fancy=$request->is_fancy ?? 0;
          
      
          // $where = "cash_price >= 35 AND is_fancy = '$is_fancy'";
          $where = "cash_price >= 35 AND is_fancy = '$is_fancy' AND certificate IS NOT NULL AND certificate != ''";


          // $stock = $request->stock;       
          // if(!empty($stock)) {                   
          //   $replacedStr = str_replace("," , "','", $stock);    
          //   $where .= " AND stock_id IN ('$replacedStr') OR  `Certificate` IN ('$replacedStr')"; 
          //   // $where .= " AND stock_id IN ('$replacedStr') OR  `Certificate` Like '%$replacedStr%'"; 
          // } 

          $stock = $request->stock;
          if (!empty($stock)) {
              // Replace commas with the pattern delimiter for SQL LIKE ('%' in this case)
              $replacedStr = str_replace(",", "%' OR `Certificate` LIKE '%", $stock);
              
              // Construct the WHERE clause to match patterns using LIKE
              $where .= " AND (stock_id LIKE '%$replacedStr%' OR `Certificate` LIKE '%$replacedStr%')";
          }

      
          // $color = $request->color;                  
          // if(!empty($color)) {
          //   if(in_array('M', $color)) {
          //     array_push($color, "N", "O", "P", "Q", "R", "S");
          //   }
          //   $q = implode("','",$color);
          //   $where .= " AND color IN ('$q')";           
          // }

          $shape = $request->checkbox;
          // print_ex($shape);
          if (!empty($shape)) {
            $replacedStr = implode("','",$shape);             
            $where .= " AND shape IN ('$replacedStr')";      
          }

          $color = $request->color;                   
          if($is_fancy == '0'){
            if(!empty($color))
            {
                $color_array=array("D", "E", "F", "G", "H");
                $color_array=$this->find_range($color,$color_array);
                $q2=implode("','",$color_array);
                $where .= " AND color IN ('".$q2."')";           
            }
          }else{
            if(!empty($color))
            {
              $replacedStr = implode("','",$color);             
              $where .= " AND color IN ('$replacedStr')";
            }   
          }

          $fancy_color_intensity = $request->fancy_color_intensity;
          if(!empty($fancy_color_intensity))
          {
            $replacedStr = implode("','",$fancy_color_intensity);             
            $where .= " AND fancy_color_intensity IN ('$replacedStr')";
          }
          
          $checkboxcut = $request->cut;                
          if(!empty($checkboxcut))
          {         
              $array_va=array("EX", "VG", "G", "FR");
              $checkboxcut=$this->find_range($checkboxcut,$array_va);
              // if(in_array('Round',  $shape))
              // {
                $qcut = implode("','", $checkboxcut);
                $where .= " AND cut IN ('".$qcut."')";
              // }                  
          } 
          
          $checkboxClarity = $request->clarity;
          if(!empty($checkboxClarity))
          {        
            // $clarity_va=array("FL","IF","VVS1","VVS2","VS1","VS2","SI1","SI2","SI3","I1","I2","I3");
            $clarity_va=array("FL","IF","VVS1","VVS2","VS1","VS2","SI1","SI2","SI3","I1","I2","I3");
            $checkboxClarity=$this->find_range($checkboxClarity,$clarity_va);
            $qClarity = implode("','", $checkboxClarity);
            $where .= " AND clarity IN ('".$qClarity."')";
          }  


          // $price_from = $request->price_from / 1.50;
          // $price_to = $request->price_to / 1.50;

          $price_from = $request->price_from;
          $price_to = $request->price_to;

          if (trim($price_from) != '' && trim($price_to)) {      
            $price_to = ($price_to=='0') ? '10000000' : $price_to;
            $where .= " AND cash_price BETWEEN ($price_from) AND ($price_to)";
          }

          // $price_from = $request->price_from;
          // $price_to = $request->price_to;
          // if (trim($price_from) != '' && trim($price_to)) {      
          //   $price_to = ($price_to=='0') ? '10000000' : $price_to;
          //   $where .= " AND cash_price BETWEEN ($price_from) AND ($price_to)";
          // }

          $carat_from = $request->carat_from;
          $carat_to = $request->carat_to;
          if (trim($carat_from) != '' && trim($carat_to)) {      
            $carat_to = ($carat_to=='0') ? '200' : $carat_to;
            $where .= " AND weight BETWEEN ($carat_from) AND ($carat_to)";
          }

          $lab = $request->lab;
          // print_ex($shape);
          if (!empty($lab)) {
            $replacedStr = implode("','",$lab);             
            $where .= " AND lab IN ('$replacedStr')";      
          }
          
          $where .= " AND lab NOT LIKE '%MATCHING PAIR%'";

          // $range = $request->carat_from;
          // $split = explode(';', $range);
          // $split1 = @$split['0'];    
          // $split2 = @$split['1'];
          // if($split2=='6'){
          //   $split2 = '20';
          // }     
          // if(!empty($range))
          // {        
          //   $where .= " AND weight BETWEEN ('".$split1."') AND ('".$split2."')";     
          // }



          // $polish = $request->polish;
          // if (!empty($polish)) {
          //   $replacedStr = implode("','",$polish);             
          //   $where .= " AND polish IN ('$replacedStr')";      
          // }

          // $symmetry = $request->symmetry;
          // if (!empty($symmetry)) {
          //   $replacedStr = implode("','",$symmetry);             
          //   $where .= " AND symmetry IN ('$replacedStr')";      
          // }

          
          // $fluorescence = $request->fluorescence;
          // if (!empty($fluorescence)) {
          //   $replacedStr = implode("','",$fluorescence);             
          //   $where .= " AND fluorescence_int IN ('$replacedStr')";      
          // }

          // $cert = $request->cert;
          // if (!empty($cert)) {
          //   $replacedStr = implode("','",$cert);             
          //   $where .= " AND lab IN ('$replacedStr')";      
          // }

          // $culet = $request->culet;
          // if (!empty($culet)) {
          //   $replacedStr = implode("','",$culet);             
          //   $where .= " AND culet IN ('$replacedStr')";      
          // }

          // $table_per_from = $request->table_per_from;
          // $table_per_to = $request->table_per_to;
          // if (trim($table_per_from) != '' && trim($table_per_to)) {      
          //   $table_per_to = ($table_per_to=='10') ? '200' : $table_per_to;
          //   $where .= " AND table_d BETWEEN ($table_per_from) AND ($table_per_to)";
          // }

          // $depth_per_from = $request->depth_per_from;
          // $depth_per_to = $request->depth_per_to;
          // if (trim($depth_per_from) != '' && trim($depth_per_to)) {      
          //   $depth_per_to = ($depth_per_to=='10') ? '200' : $depth_per_to;
          //   $where .= " AND depth BETWEEN ($depth_per_from) AND ($depth_per_to)";
          // }

          // $cr_angle_from = $request->cr_angle_from;
          // $cr_angle_to = $request->cr_angle_to;
          // if (trim($cr_angle_from) != '' && trim($cr_angle_to)) {      
          //   $cr_angle_to = ($cr_angle_to=='10') ? '200' : $cr_angle_to;
          //   $where .= " AND crown_angle BETWEEN ($cr_angle_from) AND ($cr_angle_to)";
          // }

          // $cr_height_from = $request->cr_height_from;
          // $cr_height_to = $request->cr_height_to;
          // if (trim($cr_height_from) != '' && trim($cr_height_to)) {      
          //   $cr_height_to = ($cr_height_to=='10') ? '200' : $cr_height_to;
          //   $where .= " AND crown_ht BETWEEN ($cr_height_from) AND ($cr_height_to)";
          // }

          // $pav_angle_from = $request->pav_angle_from;
          // $pav_angle_to = $request->pav_angle_to;
          // if (trim($pav_angle_from) != '' && trim($pav_angle_to)) {      
          //   $pav_angle_to = ($pav_angle_to=='10') ? '200' : $pav_angle_to;
          //   $where .= " AND pavillion_angle BETWEEN ($pav_angle_from) AND ($pav_angle_to)";
          // }

          // $pav_height_from = $request->pav_height_from;
          // $pav_height_to = $request->pav_height_to;
          // if (trim($pav_height_from) != '' && trim($pav_height_to)) {      
          //   $pav_height_to = ($pav_height_to=='10') ? '200' : $pav_height_to;
          //   $where .= " AND pavillion_depth BETWEEN ($pav_height_from) AND ($pav_height_to)";
          // }

          // $girdle_per_from = $request->girdle_per_from;
          // $girdle_per_to = $request->girdle_per_to;
          // if (trim($girdle_per_from) != '' && trim($girdle_per_to)) {      
          //   $girdle_per_to = ($girdle_per_to=='10') ? '200' : $girdle_per_to;
          //   $where .= " AND girdle_perct BETWEEN ($girdle_per_from) AND ($girdle_per_to)";
          // }

          // $star_len_from = $request->star_len_from;
          // $star_len_to = $request->star_len_to;
          // if (trim($star_len_from) != '' && trim($star_len_to)) {      
          //   $star_len_to = ($star_len_to=='10') ? '200' : $star_len_to;
          //   $where .= " AND star_len BETWEEN ($star_len_from) AND ($star_len_to)";
          // }


          // Get the sorting parameters from Ajax request
            // $sortBy = isset($request->sortBy) ? $request->sortBy : 'cash_price'; // Default column is 'shapes'
            // $order = isset($request->order) ? $request->order : 'asc'; // Default order is 'asc'

            // // Define valid columns for sorting
            // $validColumns = ['shape', 'cts', 'color', 'clarity', 'cut', 'cash_price', 'lab'];
            // if (!in_array($sortBy, $validColumns)) {
            //     $sortBy = 'shape'; // Default column if invalid
            // }


            // Query to fetch sorted data
            // $query = "SELECT * FROM diamonds ORDER BY $sortBy $order";

          // ------------

          $per_pages = $request->per_pages ?? 50;
          $limit = ($per_pages != '') ? $per_pages : $per_page ;
          $offset = ($page - 1) * $limit;
         
          $orders = "ORDER BY cash_price ASC";
          $query = "select * from tbl_diamond where " .$where." $orders limit $offset,$limit"; 
          // $query = "select * from tbl_diamond where " .$where." ORDER BY $sortBy $order limit $offset,$limit"; 

          // $query = "select * from tbl_diamond where " .$where." limit $offset,$limit"; 
          $records = DB::select($query);
          // echo $records; die;
          
          $query1 = "select COUNT(diamond_id) AS diamond_count from tbl_diamond where " .$where;
          $records_count = DB::select($query1);
          $data['records_count'] =$records_count['0']->diamond_count;

          // $query2 = "select COUNT(diamond_id) AS diamond_count from tbl_diamond where " .$where;
          // $records_count2 = DB::select($query2);
         
            $total_records = $records_count[0]->diamond_count;
            
            // Generate pagination links
            $pagination = $this->generate_pagination($page, $total_records, $limit);

          $response_data = [
            'product_id' => $product_id ?? '',
            'variants_id' => $variants_id ?? '',
            'records' => $records,
            'page_link' => $pagination ?? '',
            'total_records' => $data['records_count'],
            // 'query' => $query,
            'theme_json' => $theme_json ?? '',
            'isLogin' => 1,
            'page_name' => $page_name
        ];
    
        return response()->json($response_data)
                         ->header('Access-Control-Allow-Origin', '*')
                         ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
                         ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');
        }
       
    }
    
    public function generate_pagination($current_page, $total_records, $per_page)
    {
        $total_pages = ceil($total_records / $per_page); // Calculate total pages
    
        $pagination = '';
    
        // Previous Button
        if ($current_page > 1) {
            $pagination .= '<a href="javascript:void(0);" onclick="loadMoreData(\'https://caratsperfect.com/carat-perfect-app/load-more-diamond?page='.($current_page - 1).'\')" class="pagination-btn">Previous</a>';
        }
    
        // Page Numbers
        $page_range = 2; // Display 2 pages before and after the current page
        $start_page = max(1, $current_page - $page_range);
        $end_page = min($total_pages, $current_page + $page_range);
    
        // Add first page and "..." if there's a gap
        if ($start_page > 1) {
            $pagination .= '<a href="javascript:void(0);" onclick="loadMoreData(\'https://caratsperfect.com/carat-perfect-app/load-more-diamond?page=1\')" class="pagination-btn">1</a>';
            if ($start_page > 2) {
                $pagination .= '<span class="pagination-dots">...</span>';
            }
        }
    
        // Loop through the page numbers
        for ($i = $start_page; $i <= $end_page; $i++) {
            if ($i == $current_page) {
                $pagination .= '<a href="javascript:void(0);" class="pagination-btn active">' . $i . '</a>';
            } else {
                $pagination .= '<a href="javascript:void(0);" onclick="loadMoreData(\'https://caratsperfect.com/carat-perfect-app/load-more-diamond?page='.$i.'\')" class="pagination-btn">' . $i . '</a>';
            }
        }
    
        // Add last page and "..." if there's a gap
        if ($end_page < $total_pages) {
            if ($end_page < $total_pages - 1) {
                $pagination .= '<span class="pagination-dots">...</span>';
            }
            $pagination .= '<a href="javascript:void(0);" onclick="loadMoreData(\'https://caratsperfect.com/carat-perfect-app/load-more-diamond?page='.$total_pages.'\')" class="pagination-btn">'.$total_pages.'</a>';
        }
    
        // Next Button
        if ($current_page < $total_pages) {
            $pagination .= '<a href="javascript:void(0);" onclick="loadMoreData(\'https://caratsperfect.com/carat-perfect-app/load-more-diamond?page='.($current_page + 1).'\')" class="pagination-btn">Next</a>';
        }
    
        return $pagination;
    }
    

    public function diamond_details(Request $request){
     
      $stock_id = $request->stock_id;
      $vendor_id = $request->vendor_id;

      $diamond_query = "select * from tbl_diamond where stock_id = '$stock_id' limit 1";
      // $diamond_query = "select * from tbl_diamond where stock_id = '$stock_id' and vendor_id = '$vendor_id'  limit 1";
      $diamond_record = DB::select($diamond_query);
      $response_data = [
        'records'=>$diamond_record,
        // 'page_name' => $page_name
      ];
      
      return response()->json($response_data)
                         ->header('Access-Control-Allow-Origin', '*')
                         ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
                         ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');
    }

    public function add_to_cart(Request $request){
     
      $stock_id = $request->stock_id;
      $vendor_id = $request->vendor_id;
      $shop_name = $request->shop_name;

      $user_query = "select * from users where name = '$shop_name' limit 1";
      $user_record = DB::select($user_query);
      $user_id = $user_record[0]->id;


      $cart_query = "select * from tbl_cart where stock_id = '$stock_id' and vendor_id = '$vendor_id'  limit 1";
      $cart_record = DB::select($cart_query);

      $diamond_query = "select * from tbl_diamond where stock_id = '$stock_id' and vendor_id = '$vendor_id'  limit 1";
      $record = DB::select($diamond_query);
      if(empty($cart_record)){
        if(!empty($record)){
          foreach($record as $row) {
            if(!empty($row->diamond_image)){
              $diamond_img = $row->diamond_image;
              $alt = $row->shape;
            }else{
              $diamond_img = asset('assets/no_image.jpg');
              $alt = "No image";	
            }

            $vendor = $row->vendor_name." ".$row->vendor_id;
            // $row->Buy_Price = $row->Buy_Price * 1.50;
            $row->Buy_Price = $row->Buy_Price;

            $variants = [
              'sku' => $row->stock_id,
              // 'barcode' => $row->barcode,
              'price' => $row->Buy_Price,
              // 'compare_at_price' => $row->Buy_Price,
              'cost' =>$row->Buy_Price,                    
              'inventory_quantity' => 1,
              // 'grams' => $row->grams,
              'taxable' => true,
              'requires_shipping' => true,
              'fulfillment_service' => 'manual',
              'inventory_policy' => 'deny',
              'inventory_management' => 'shopify'
            ];
      
          
            $row->title = $row->weight . " Carat " . $row->shape ." ". $row->color ." ". $row->clarity . " Lab Diamond ";
            // $row->title = "Demo Lab Diamond";

            $is_fancy = ($row->is_fancy == 1) ? 'fancy' : 'not_fancy';
            $dataSend = [
              'product' => [
                'title' => $row->title,
                'body_html' => $row->description,
                'product_type' => 'lab_grown_diamonds',
                'handle' => $row->stock_id,
                'status' => 'active',
                'vendor' => $vendor,
                'published_scope' => 'pos',
                'tags' => $is_fancy,
                'variants' => [
                  $variants
                ],
                'images' => [
                  [
                    "position"=> 1,
                    "alt"=> $alt,
                    "src"=> $diamond_img 
                  ]
                ],
                'metafields' => [
                      [
                        'namespace' => "Diamond",
                        'key' => "stock_id",
                        'value' => $row->stock_id,
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "title",
                        'value' => $row->title,
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "availability",
                        'value' => !empty($row->availability) ? $row->availability : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "shape",
                        'value' => !empty($row->shape) ? $row->shape : 'Other',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "weight",
                        'value' => (!empty($row->weight)) ? $row->weight : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "color",
                        'value' => !empty($row->color) ? $row->color : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "clarity",
                        'value' => !empty($row->clarity) ? $row->clarity : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "cut",
                        'value' => !empty($row->cut) ? $row->cut : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "polish",
                        'value' => !empty($row->polish) ? $row->polish : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "symmetry",
                        'value' => !empty($row->symmetry) ? $row->symmetry : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "fluor",
                        'value' => !empty($row->fluorescence_int) ? $row->fluorescence_int : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "Fluorescence_Color",
                        'value' => !empty($row->fluorescence_color) ? $row->fluorescence_color : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "measurements",
                        'value' => !empty($row->measurements) ? $row->measurements : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "lab",
                        'value' => !empty($row->lab) ? $row->lab : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "depth",
                        'value' => !empty($row->depth) ? $row->depth : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "table_d",
                        'value' => !empty($row->table_d) ? $row->table_d : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "culet_size",
                        'value' => (!empty($row->culet_size)) ? $row->culet_size : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "crown_angle",
                        'value' => (!empty($row->crown_angle)) ? $row->crown_angle : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "crown_ht",
                        'value' => (!empty($row->crown_ht)) ? $row->crown_ht : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "pavillion_angle",
                        'value' => (!empty($row->pavillion_angle)) ? $row->pavillion_angle : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "pavillion_depth",
                        'value' => (!empty($row->pavillion_depth)) ? $row->pavillion_depth : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "star_len",
                        'value' => (!empty($row->star_len)) ? $row->star_len : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "Member_Comments",
                        'value' => (!empty($row->member_comment)) ? $row->member_comment : 'None',
                        'type' => "multi_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "country",
                        'value' => (!empty($row->country)) ? $row->country : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "state",
                        'value' => (!empty($row->state)) ? $row->state : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "city",
                        'value' => (!empty($row->city)) ? $row->city : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "price",
                        'value' => (!empty($row->Buy_Price)) ? $row->Buy_Price : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "ratio",
                        'value' => (!empty($row->ratio)) ? $row->ratio : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "ImageLink",
                        'value' => (!empty($row->diamond_image)) ? $row->diamond_image : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "VideoLink",
                        'value' => (!empty($row->diamond_video)) ? $row->diamond_video : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "Video_HTML",
                        'value' => (!empty($row->Video_HTML)) ? $row->Video_HTML : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "CertificateLink",
                        'value' => (!empty($row->CertificateLink)) ? $row->CertificateLink : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "Rap_Price",
                        'value' => (!empty($row->rapnet)) ? $row->rapnet : "None",
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "growth_type",
                        'value' => (!empty($row->growth_type)) ? $row->growth_type : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "short_title",
                        'value' => (!empty($row->short_title)) ? $row->short_title : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "is_fancy",
                        'value' => (!empty($row->is_fancy)) ? $row->is_fancy : 1,
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "vendor_name",
                        'value' => (!empty($row->vendor_name)) ? $row->vendor_name : 'None',
                        'type' => "single_line_text_field",
                      ],
                      [
                        'namespace' => "Diamond",
                        'key' => "vendor_id",
                        'value' => (!empty($row->vendor_id)) ? $row->vendor_id : "None",
                        'type' => "single_line_text_field",
                      ]

                ],
              ]

            ];
          }

          $newRecord = $this->createDiamonds(json_encode($dataSend),$shop_name);
        
          if(empty($newRecord)){
                  $response_data = [
                    'message'=>$newRecord ?? ''
                  ];
                  
                  return response()->json($response_data)
                                    ->header('Access-Control-Allow-Origin', '*')
                                    ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
                                    ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');
                                    die;         
          }else{

            // $user_id = 6;
            $product_id = $newRecord->product->id;
            $variant_id = $newRecord->product->variants[0]->id;
            $quantity = 1;
            $price = $row->Buy_Price;
            // $vendor_id= $vendor;
            $shopify_response = json_encode($newRecord);
            $shopify_upload = 1;
            $shopify_update = 0;
            $shopify_delete = 0;
            $created_at = date('Y-m-d H:i:s');
            $updated_at = date('Y-m-d H:i:s');
            try {
              DB::insert("
                  INSERT INTO tbl_cart (
                      user_id,
                      stock_id,
                      product_id,
                      variant_id,
                      quantity,
                      price,
                      vendor_id,
                      shopify_response,
                      shopify_upload,
                      shopify_update,
                      shopify_delete,
                      created_at,
                      updated_at
                  ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
                  [$user_id, $stock_id, $product_id, $variant_id, $quantity, $price, $vendor_id, $shopify_response, $shopify_upload, $shopify_update, $shopify_delete, $created_at, $updated_at]
              );

              $cart_querys = "select * from tbl_cart where stock_id = '$stock_id' and vendor_id = '$vendor_id'  limit 1";
              $cart_records = DB::select($cart_querys);

              $response_data = [
                'records'=>$cart_records ?? '',
                'message'=>'Product upload successfully',
                'status'=>'true'
              ];
              
              return response()->json($response_data)
                                ->header('Access-Control-Allow-Origin', '*')
                                ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
                                ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');

              // echo "Data inserted successfully!";
            } catch (QueryException $e) { 
              $response_data = [
                'records'=>$record ?? [],
                'message'=>$e->getMessage() ?? '',
                'status'=>'false'
              ];
              
              return response()->json($response_data)
                                ->header('Access-Control-Allow-Origin', '*')
                                ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
                                ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');
                // echo "Error inserting data: " . $e->getMessage();
            }
          }
        }
      }else{

        $cart_querys = "select * from tbl_cart where stock_id = '$stock_id' and vendor_id = '$vendor_id'  limit 1";
        $cart_records = DB::select($cart_querys);

        $updated_date = date('Y-m-d', strtotime($cart_records[0]->updated_at));
        $current_date = date('Y-m-d');
        
        // if ($updated_date !== $current_date) {
            
            $response_data = [
              'records'=>$cart_records ?? [],
              'message'=>'successfully',
              'status'=>'true'
            ];

            return response()->json($response_data)
              ->header('Access-Control-Allow-Origin', '*')
              ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
              ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');
            // ----- Nee karna Bad Me karuga By 
        // } else {
        
        //   $updateLocal = [];
        //   if (!empty($record)) {
      
        //     foreach ($record as $row) {
        //       $row->product_id = $cart_record[0]->product_id;

        //       if(!empty($row->diamond_image)){
        //         $diamond_img = $row->diamond_image;
        //         $alt = $row->shape;
        //       }else{
        //         $diamond_img = asset('assets/no_image.jpg');
        //         $alt = "No image";	
        //       }

        //       $vendor = $row->vendor_name." ".$row->vendor_id;
        //       $row->Buy_Price = $row->Buy_Price * 1.50;
              
        //       $row->title = $row->weight . " Carat " . $row->shape . " Lab Diamond demo";
      
        //       $variants = [
      
        //         'price' => $row->Buy_Price,
      
        //         'cost' => $row->Buy_Price,
      
        //         'inventory_quantity' => 10,
      
        //         'taxable' => true,
      
        //         'requires_shipping' => true,
      
        //         'fulfillment_service' => 'manual',
      
        //         'inventory_policy' => 'deny',
      
        //         'inventory_management' => 'shopify'
      
        //       ];
      
        
        //       $is_fancy = ($row->is_fancy == 1) ? 'fancy' : 'not_fancy';
        //       $dataSend = [
      
        //         'product' => [
      
        //           'id' => $row->product_id,
      
        //           'title' => $row->title,
      
        //           'body_html' => $row->description,
      
        //           'product_type' => 'lab_grown_diamonds',
      
        //           'handle' => $row->stock_id,
      
        //           'status' => 'active',
      
        //           'vendor' => $vendor,

        //           'published_scope' => 'pos',
        //           'tags' => $is_fancy,
        //           'variants' => [
      
        //             $variants
      
        //           ],
      
        //           'images' => [
      
        //             [
      
        //               "position" => 1,
      
        //               "alt" => $alt,
      
        //               "src" => $diamond_img 
      
        //             ]
      
        //           ]
      
        //         ]
      
        //       ];


        //       $updatedRecord = $this->updateDiamonds(json_encode($dataSend), $row->product_id, $shop_name);
              
      
        //       if(empty($updatedRecord->product)){

                
        //         $response_data = [
        //           'records'=>$cart_records ?? [],
        //           'message'=> 'successfully update',
        //           'status'=> 'true'
        //         ];
                
        //         return response()->json($response_data)
        //                           ->header('Access-Control-Allow-Origin', '*')
        //                           ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
        //                           ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');
        //       }
      
        //       $newRecord = $this->updateMetafield($row, $row->product_id, $shop_name);
      
        //       $update_query = "UPDATE tbl_cart 
        //           SET shopify_update = '1' 
        //           WHERE stock_id = '$stock_id' AND vendor_id = '$vendor_id' 
        //           LIMIT 1";
        //       $updated_rows = DB::update($update_query);  

        //       $response_data = [
        //         'records'=>$cart_records ?? [],
        //         'message'=> $newRecord,
        //         'status'=> 'true'
        //       ];
              
        //       return response()->json($response_data)
        //                         ->header('Access-Control-Allow-Origin', '*')
        //                         ->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
        //                         ->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');

    
        //       // date_default_timezone_set('Asia/Kolkata');
        //       // $current_dt = date('Y-m-d h:i A');
        //       // $tbl_inventory_data = [
        //       //   'stock_id' => $row->stock_id,
        //       //   'vendor_id' => $row->vendor_id,
        //       //   'product_id' => $row->product_id,
        //       //   'insert_update_delete' => "update",
        //       //   'date_time' => $current_dt,
        //       // ];
        //       // $this->db->insert('tbl_inventory', $tbl_inventory_data);
              
      
        //     }
      
        //   }

        // }

            // ----- Nee karna Bad Me karuga By unknown person
        
      }

    }

    function createDiamonds($jsonBody,$shop_name)
    {
        // print_ex($accessToken);
        if(empty($jsonBody)) {
          return [];
        }
      
        $shop_url = 'https://'.$shop_name.'/admin/api/2024-10/products.json'; // Replace with your Shopify store URL
        // $accessToken = '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'; // Replace with your access token
        $accessToken = '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'; // Replace with your access token

        $client = new Client([
            'base_uri' => $shop_url,
        ]);

        $headers = [
            'Content-Type' => 'application/json',
            'X-Shopify-Access-Token' => $accessToken,
        ];

        try {
            $response = $client->request('POST', 'https://'.$shop_name.'/admin/api/2024-07/products.json', [
                'headers' => $headers,
                'body' => $jsonBody,
            ]);

            $body = $response->getBody();
            $parsedBody = json_decode($body);
            // print_r($parsedBody);
            return $parsedBody;

            // return response()->json($parsedBody); // Return JSON response from Shopify
        } catch (\Exception $e) {
            return [];
            // return response()->json(['error' => $e->getMessage()], 500); // Handle any errors
        }
    }


function getProductPublications() {
    $client = new Client();
    $shopifyUrl = 'https://12cd8f-f4.myshopify.com'; // Replace with your Shopify store URL
    $accessToken = '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'; // Replace with your access token

    try {
        // Send GET request to fetch products with publication details
        $response = $client->get("{$shopifyUrl}/admin/api/2023-10/products.json", [
            'headers' => [
                'Content-Type' => 'application/json',
                'X-Shopify-Access-Token' => $accessToken,
            ],
        ]);

        // Parse the response body
        $products = json_decode($response->getBody(), true);

        // Print the list of products and their published scope
        print_r($products);

    } catch (\Exception $e) {
        // Handle any exceptions that occur
        echo 'Error: ' . $e->getMessage();
    }
}

function getSalesChannelIds() {
    $client = new Client();
    $shopifyUrl = 'https://12cd8f-f4.myshopify.com'; // Replace with your Shopify store URL
    $accessToken = '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'; // Replace with your access token

    try {
        // Send GET request to fetch sales channels
        $response = $client->get("{$shopifyUrl}/admin/api/2023-10/sales_channels.json", [
            'headers' => [
                'Content-Type' => 'application/json',
                'X-Shopify-Access-Token' => $accessToken,
            ],
        ]);

        // Parse the response body
        $salesChannels = json_decode($response->getBody(), true);

        // Check if sales channels were returned
        if (isset($salesChannels['sales_channels']) && !empty($salesChannels['sales_channels'])) {
            // Print the sales channels and their IDs
            foreach ($salesChannels['sales_channels'] as $channel) {
                echo 'Sales Channel ID: ' . $channel['id'] . ' - Name: ' . $channel['name'] . "\n";
            }
        } else {
            echo 'No sales channels found.\n';
        }

    } catch (\Exception $e) {
        // Handle any exceptions that occur
        echo 'Error: ' . $e->getMessage();
    }
}

public function publishProduct($productId=8873555198203)
{
    $client = new Client();
    $salesChannelAppId = 145221452027; // Replace with your Sales Channel App ID

    try {
        $response = $client->post("{https://12cd8f-f4.myshopify.com/admin/api/2024-10/product_publications.json", [
            'headers' => [
                'Content-Type' => 'application/json',
                'X-Shopify-Access-Token' => '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',
            ],
            'json' => [
                'product_publication' => [
                    'product_id' => 8873555198203,
                    'published_scope' => 'web', // or 'POS'
                    'channel_id' => $salesChannelAppId,
                ],
            ],
        ]);

        $publication = json_decode($response->getBody(), true);
        return response()->json($publication);

    } catch (\Exception $e) {
        return response()->json(['error' => $e->getMessage()], 400);
    }
}



    private function updateDiamonds($jsonBody, $productId,$shop_name) {
      if (empty($jsonBody) || empty($productId)) {
        return [];
      }
    
      $shop_url = 'https://'.$shop_name.'/admin/api/2024-10/products.json'; // Replace with your Shopify store URL
      // $accessToken = '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'; // Replace with your access token
      $accessToken = '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'; // Replace with your access token

      $client = new Client([
        'base_uri' => $shop_url
      ]);
    
      $headers = [
        'Content-Type' => 'application/json',
        'X-Shopify-Access-Token' => $accessToken
      ];
    
      $endpoint = "products/{$productId}.json";
      $maxRetries = 5;
      $retryDelay = 1; // Start with 1 second
    
      for ($attempt = 0; $attempt < $maxRetries; $attempt++) {
        try {
          $response = $client->request('PUT', $endpoint, [
            "headers" => $headers,
            "body" => $jsonBody
          ]);
    
          if ($response->getStatusCode() < 300) {
            $body = $response->getBody();
            return json_decode($body);
          } else {
            throw new \Exception('Non-successful response');
          }
        } catch (\GuzzleHttp\Exception\ClientException $e) {
          if ($e->getCode() == 429 && $attempt < $maxRetries - 1) {
            sleep($retryDelay);
            $retryDelay *= 2; // Exponential backoff
          } else {
            error_log('API request failed: ' . $e->getMessage());
            return [];
          }
        }
      }
    
      return [];
    }

    private function updateMetafield($jsonBody, $product_id, $shop_name) {
      if (empty($jsonBody)) {
          return ['status' => 'error', 'message' => 'Empty input data'];
      }
  
      $shopUrl = 'https://' . $shop_name;
      $accessToken = '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'; // Replace with your access token
      $metafieldsUrl = "$shopUrl/admin/api/2024-10/products/$product_id/metafields.json";
      $client = new \GuzzleHttp\Client();
  
      // Fetch existing metafields
      try {
          $response = $client->request('GET', $metafieldsUrl, [
              'headers' => [
                  'X-Shopify-Access-Token' => $accessToken,
                  'Content-Type' => 'application/json',
              ]
          ]);
          
          $product_metafields = json_decode($response->getBody()->getContents(), true);
          if (!isset($product_metafields['metafields'])) {
              throw new Exception('Failed to retrieve metafields');
          }
  
      } catch (Exception $e) {
          error_log('Exception fetching metafields: ' . $e->getMessage());
          return ['status' => 'error', 'message' => $e->getMessage()];
      }
  
      // New metafield entries
      $metafields = [
          [
              'namespace' => 'Diamond',
              'key' => 'stock_id',
              'value' => $jsonBody->stock_id,
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'title',
              'value' => $jsonBody->title,
              'type' => 'single_line_text_field',
          ],
          [
            'namespace' => 'Diamond',
            'key' => 'short_title',
            'value' => !empty($jsonBody->short_title) ? $jsonBody->short_title : 'Default Title',
            'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'availability',
              'value' => !empty($jsonBody->availability) ? $jsonBody->availability : 'None',
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'shape',
              'value' => !empty($jsonBody->shape) ? $jsonBody->shape : 'Other',
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'weight',
              'value' => $jsonBody->weight,
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'color',
              'value' => !empty($jsonBody->color) ? $jsonBody->color : 'None',
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'clarity',
              'value' => !empty($jsonBody->clarity) ? $jsonBody->clarity : 'None',
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'cut',
              'value' => !empty($jsonBody->cut) ? $jsonBody->cut : 'None',
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'polish',
              'value' => !empty($jsonBody->polish) ? $jsonBody->polish : 'None',
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'symmetry',
              'value' => !empty($jsonBody->symmetry) ? $jsonBody->symmetry : 'None',
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'fluor',
              'value' => !empty($jsonBody->fluorescence_int) ? $jsonBody->fluorescence_int : 'None',
              'type' => 'single_line_text_field',
          ],
          [
              'namespace' => 'Diamond',
              'key' => 'Fluorescence_Color',
              'value' => !empty($jsonBody->fluorescence_color) ? $jsonBody->fluorescence_color : 'None',
              'type' => 'single_line_text_field',
          ],
          [
            'namespace' => 'Diamond',
            'key' => 'VideoLink',
            'value' => !empty($jsonBody->diamond_video) ? $jsonBody->diamond_video : 'None',
            'type' => 'single_line_text_field',
          ],
          // Add more fields as necessary
      ];
  
      foreach ($metafields as $metafield) {
          $meta_id = null;
  
          // Check if the metafield already exists
          foreach ($product_metafields['metafields'] as $existingMetafield) {
              if ($existingMetafield['key'] === $metafield['key'] && $existingMetafield['namespace'] === 'Diamond') {
                  $meta_id = $existingMetafield['id'];
                  break;
              }
          }
  
          // Update or create metafield
          if ($meta_id) {
              // Update existing metafield
              $updateUrl = "$shopUrl/admin/api/2024-10/metafields/$meta_id.json";
              $data = [
                  'metafield' => [
                      'id' => $meta_id,
                      'value' => $metafield['value'],
                      'type' => $metafield['type'],
                  ]
              ];
  
              try {
                  $response = $client->request('PUT', $updateUrl, [
                      'headers' => [
                          'X-Shopify-Access-Token' => $accessToken,
                          'Content-Type' => 'application/json',
                      ],
                      'json' => $data
                  ]);
  
                  if ($response->getStatusCode() >= 300) {
                      throw new Exception('Error updating metafield: ' . $response->getBody()->getContents());
                  }
  
              } catch (Exception $e) {
                  error_log('Exception updating metafield: ' . $e->getMessage());
                  return ['status' => 'error', 'message' => 'Failed to update metafield: ' . $metafield['key']];
              }
  
          } else {
              // Create new metafield
              $createUrl = "$shopUrl/admin/api/2024-10/products/$product_id/metafields.json";
              $data = [
                  'metafield' => $metafield
              ];
  
              try {
                  $response = $client->request('POST', $createUrl, [
                      'headers' => [
                          'X-Shopify-Access-Token' => $accessToken,
                          'Content-Type' => 'application/json',
                      ],
                      'json' => $data
                  ]);
  
                  if ($response->getStatusCode() >= 300) {
                      throw new Exception('Error creating metafield: ' . $response->getBody()->getContents());
                  }
  
              } catch (Exception $e) {
                  error_log('Exception creating metafield: ' . $e->getMessage());
                  return ['status' => 'error', 'message' => 'Failed to create metafield: ' . $metafield['key']];
              }
          }
      }
  
      return ['status' => 'success', 'message' => 'Metafields updated or created successfully'];
    }
  

    // Add item to Shopify Cart
    public function addToCart(Request $request)
    {
      // return response()->json([
      //   'success' => $request->variant_id,
      //   'message' => 'Failed to add item to cart. hello',
      // ]); die;
        // // Validate incoming request data
        // $request->validate([
        //     'product_id' => 'required|integer',
        //     'variant_id' => 'required|integer',
        //     'quantity' => 'required|integer',
        // ]);

        // Shopify Storefront API endpoint and credentials
        $shop_url = 'https://12cd8f-f4.myshopify.com';
        // $access_token = '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';
        $access_token = '14cb01616f189ce2b139feeb60cc3f21';
        
        // Setup Guzzle client
        $client = new Client();
        
        // Cart creation query
        $response = $client->post("{$shop_url}/api/2021-10/graphql.json", [
            'headers' => [
                'X-Shopify-Storefront-Access-Token' => $access_token,
                'Content-Type' => 'application/json',
            ],
            'json' => [
                'query' => '
                mutation {
                  checkoutCreate(input: {lineItems: [{variantId: "gid://shopify/ProductVariant/'.$request->variant_id.'", quantity: '.$request->quantity.'}]}) {
                    checkout {
                      id
                      lineItems(first: 5) {
                        edges {
                          node {
                            title
                            quantity
                            variant {
                              id
                              title
                            }
                          }
                        }
                      }
                    }
                  }
                }
                ',
            ],
        ]);
        
        $body = json_decode($response->getBody(), true);

        // Check if the cart was created successfully
        if (isset($body['data']['checkoutCreate']['checkout']['id'])) {
            return response()->json([
                'success' => true,
                'message' => 'Item added to cart.',
                'checkout_id' => $body['data']['checkoutCreate']['checkout']['id'],
                'items' => $body['data']['checkoutCreate']['checkout']['lineItems']['edges'],
            ]);
        } else {
            return response()->json([
                'success' => false,
                'message' => 'Failed to add item to cart.',
            ]);
        }
    }
  

    public function find_range($range,$array_from)
    {
        $split = explode(';', $range);
        $split1 = @$split['0'];    
        $split2 = @$split['1'];
        $split1_key = array_search($split1, $array_from); 
        $split2_key = array_search($split2, $array_from);
        for ($i=$split1_key; $i <= $split2_key; $i++) { 
            $array[]=$array_from[$i];
        }
        return $array;
    }

    public function theme_changes(Request $request){

      $shop_name = $request->shop_name;
      $auth_token = $request->auth_token;
      $text_color = $request->text_color;
      $bg_color = $request->bg_color;
      $font_sizes = $request->font_size;
      // print_ex($font_size);
      $font_size = $font_sizes;
      $access_token = $request->access_token;

      $where = "name = '$shop_name'"; 
      // $where = "token = '$auth_token' AND name = '$shop_name'"; 
      $query = "select * from users where " .$where." limit 1";
      // print_ex($query);
      $user_data = DB::select($query); 
      if(!empty($user_data)){    
          $themeArray = [
            'text_color' => $text_color,
            'bg_color' => $bg_color,
            'font_size' => $font_size,
            'shop_name' => $shop_name,
            'auth_token' => $auth_token
          ];
          // print_ex(json_encode($themeArray));

          $update_query = "UPDATE users SET theme_json = '".json_encode($themeArray)."', token ='".$auth_token."', access_token ='".$access_token."' WHERE ".$where."";
          // print_ex($update_query);
          $rowsUpdated = DB::update($update_query);
        echo json_encode(array(
          // 'records'=>$user_data,
          'message'=> "Update Successfully."
        ));
      }else{
        echo json_encode(array(
          // 'records'=>[],
          'message'=> "Authentication Token Invaild."
        ));
      }
    }

    private function paginate($items, $perPage)
    {
        $currentPage = request()->get('page', 1); // Get the current page or default to 1

        // Slice the collection to get the items to display in current page
        $currentPageItems = array_slice($items, ($currentPage - 1) * $perPage, $perPage);

        // Create Laravel's LengthAwarePaginator instance
        return new \Illuminate\Pagination\LengthAwarePaginator(
            $currentPageItems, // Items to be paginated
            count($items),    // Total count of all items
            $perPage,         // Items per page
            $currentPage,     // Current page
            ['path' => request()->url()] // Additional paginator options
        );
    }

    function quick_detail(Request $request)
    {
      // $user_id = $this->session->userdata('user_id');
  
      // $showPrice = $this->user_model->showPrice($user_id);
      // $user_show_price = (!empty($showPrice)) ? $showPrice['0']->is_price : 0;
  
      $image_array =  $video_link = $certificate_array = [];
      $inventory_id = $request->stock_id;  
      $where = "diamond_id = '$inventory_id'"; 
        
      $query1 = "select * from tbl_diamond where " .$where;
      $records = DB::select($query1);
      // $records = $this->diamond_model->diamond_list($where);
  
      $image_array[] = $records['0']->diamond_image;
      $video_link[]=$records['0']->diamond_video;
      /*if($records['0']->report_filename!="")
      {
      if(checkLink($records['0']->report_filename)=='200'){
      $certificate_array[]=$records['0']->report_filename;
      }
      }*/
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      $isLogin = (!empty($user_id) && $user_show_price) ? 1 : 0;
  
      foreach ($records as $row) {
        $row->rapnet = '';
        if(!$isLogin) {        
          $row->rapnet_discount = $row->cost_carat = $row->total_price = '';
          $row->cash_price_discount = $row->cash_price = $row->cash_total_price = '';
        }
      }
      //print_ex($records);   
      $data= array(
        'records'=>$records,
        'image_array'=>$image_array,
        'certificate_array'=>$certificate_array ?? [],
        'video_link'=>$video_link,
        'isLogin' => $isLogin
      );
      echo json_encode($data);
    }




public function uploadDemoProduct()
{
    $shopifyUrl = 'https://12cd8f-f4.myshopify.com'; // Your Shopify store URL
    $accessToken = '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'; // Admin API access token

    // Example product data
    $productData = [
        'product' => [
            'title' => 'Demo Product',
            'body_html' => 'This is a demo product created through the Shopify API.',
            'vendor' => 'Demo Vendor',
            'product_type' => 'Demo Category',
            'tags' => 'demo, product',
            'published_scope' => 'global', // Ensure it's published globally
            'variants' => [
                [
                    'price' => '19.99',
                    'sku' => 'DEMO-SKU-001',
                    'inventory_quantity' => 100,
                    'requires_shipping' => true,
                    'taxable' => true,
                ]
            ],
            'images' => [
                [
                    'src' => 'https://via.placeholder.com/500x500.png?text=Demo+Product+Image',
                ]
            ]
        ]
    ];

    $client = new Client();

    try {
        // Step 1: Create the product
        $response = $client->post("{$shopifyUrl}/admin/api/2024-10/products.json", [
            'headers' => [
                'Content-Type' => 'application/json',
                'X-Shopify-Access-Token' => $accessToken,
            ],
            'json' => $productData
        ]);

        $responseBody = json_decode($response->getBody(), true);
        $productId = $responseBody['product']['id'];

        // Step 2: Use the "Product Publish" endpoint to associate it with a channel
        $publishResponse = $client->post("{$shopifyUrl}/admin/api/2024-10/products/{$productId}/publish.json", [
            'headers' => [
                'Content-Type' => 'application/json',
                'X-Shopify-Access-Token' => $accessToken,
            ],
            'json' => [
                'product_publication' => [
                    'product_id' => $productId,
                    'channel_id' => 'gid://shopify/Channel/online-store', // Channel ID for the online store
                ]
            ]
        ]);

        $publishResponseBody = json_decode($publishResponse->getBody(), true);

        return response()->json([
            'status' => 'success',
            'product' => $responseBody,
            'publication' => $publishResponseBody,
        ]);
    } catch (\Exception $e) {
        return response()->json([
            'status' => 'error',
            'message' => $e->getMessage(),
        ], 500);
    }
}




}
