<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Controller;
use Illuminate\Pagination\Paginator;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\ClientException;
use Illuminate\Support\Facades\Auth;
use Tymon\JWTAuth\Facades\JWTAuth;

use Illuminate\Support\Facades\Storage;

use App\Models\User;
use Illuminate\Support\Facades\View;
use App\Models\Diamond;

use DateTime;
use DateTimeZone;

class Vdb_product_raw extends Controller { 

	function getAllVdbDiamonds() {
		$records = array();
	
		$total_record = 0;
		$total_update = 0;
		$total_insert = 0;
		$total_delete = 0;
		// $vendor_id = 123;

		// Create a new DateTime object with the current date and time in UTC
		$utcDate = new DateTime('now', new DateTimeZone('UTC'));
		
		$current_date = $utcDate->format('Y-m-d\TH:i:s.v\Z');
		// echo "</br>";
		$utcDate->modify('-10 minutes');
		$filter_date = $utcDate->format('Y-m-d\TH:i:s.v\Z');

		$this->truncateDiamondTables();
		
		$curl = curl_init();
	
		curl_setopt_array($curl, array(
			// CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds?type=Lab_grown_Diamond&page_number=1&page_size=50&with_images=true&updated_at='.$filter_date,
			CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds?type=Lab_grown_Diamond&page_number=1&page_size=50&with_images=true',
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_ENCODING => '',
			CURLOPT_MAXREDIRS => 10,
			CURLOPT_TIMEOUT => 0,
			CURLOPT_FOLLOWLOCATION => true,
			CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			CURLOPT_CUSTOMREQUEST => 'GET',
			CURLOPT_HTTPHEADER => array(
				'Authorization: Token token=4ujQnUscjOG_BWpCXwBTBqwTtYzHkQ_RUvkPtNJBGXo, api_key=_j1wfVmJTpz1noOAU_9aVlA'
			),
		));

		$responses = curl_exec($curl);
		curl_close($curl);
		$data_length = json_decode($responses, true);
		// $this->print_ex($data_length); die;

		$total_diamonds_found = floor($data_length['response']['body']['total_diamonds_found'] / 50 + 1);

		// $query = "select stock_id,vendor_id,Buy_Price,shape,weight,color,clarity,cut_grade,polish,symmetry,measurements,lab,is_fancy,Certificate from tbl_vdb_diamond limit 150000"; 
		$query = "select stock_id from tbl_vdb_diamond limit 150000"; 
		$records = DB::select($query);
		$existingStockIds = array_column($records, 'stock_id');
		// $this->print_ex($records); die;
		for ($page = 1; $page <= $total_diamonds_found; $page++) {
			// for ($page = 1; $page <= 5; $page++) {
			// echo "heloo";
			// break;
			

			$curl = curl_init();
	
			curl_setopt_array($curl, array(
				// CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds?type=Lab_grown_Diamond&page_number=' . $page . '&page_size=50&with_images=true&updated_at='.$filter_date,
				CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds?type=Lab_grown_Diamond&page_number=' . $page . '&page_size=50&with_images=true',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'GET',
				CURLOPT_HTTPHEADER => array(
					'Authorization: Token token=4ujQnUscjOG_BWpCXwBTBqwTtYzHkQ_RUvkPtNJBGXo, api_key=_j1wfVmJTpz1noOAU_9aVlA'
				),
			));
	
			$response = curl_exec($curl);
			curl_close($curl);
	
			$data = json_decode($response, true);
			
			if (isset($data['response']['body']['diamonds'])) {

				$diamondRecord = $data['response']['body']['diamonds'];
				foreach ($diamondRecord as $row) {

					$vendor_id = $row['vendor_id'];
					// $vendor_name = $row['vendor_name'];
					$vendor_name = ($row['vendor_name'] != '') ? str_replace('🔹', '', $row['vendor_name']) : 'dummy';
					$stock_No = $row['stock_num'];

					$diamondData = $this->vdbDiamond($row, $vendor_id);

					if (in_array($stock_No, $existingStockIds)) {

						$existingStockIds = array_diff($existingStockIds, [$stock_No]);

						// $single_query = "select * from tbl_vdb_diamond where stock_id = '$stock_No' and vendor_id = '$vendor_id' limit 1"; 
						$single_query = "select vendor_id, created_at, edited_at from tbl_vdb_diamond where stock_id = '$stock_No' and vendor_id = '$vendor_id' limit 1"; 
						$record = DB::select($single_query);

						if($record[0]->vendor_id == $diamondData['vendor_id'] && $record[0]->created_at != $diamondData['created_at'] || $record[0]->edited_at != $diamondData['edited_at']){
							$this->updateDiamondRecord($diamondData, $stock_No, $vendor_id);
							$total_update++;
						}

					}else{

						$this->insertDiamondRecord($diamondData, $stock_No, $vendor_id, $vendor_name);
						$total_insert++;

					}
					
					$total_record++;

				}
				
			}
		}

		// Mark remaining stocks as deleted
		foreach ($existingStockIds as $stock_id) {
			$this->markDiamondAsDeleted($stock_id);
			$total_delete++;
		}

		$log_data = [
			'total_record' => $total_record,
			'total_update' => $total_update,
			'total_insert' => $total_insert,
			'total_delete' => $total_delete,
			'file' => 'VDB Diamonds',
			'log_time' => now(), // Use Laravel's helper for the current timestamp
			'type' => 'Lab Grown',
			'vendor_id' => $vendor_id,
		];
		
		// Insert the log data into the database
		DB::table('tbl_vdb_inventory_log')->insert($log_data);
	}

	private function vdbDiamond($row, $vendor_id) {
		// print_ex($row);
		$stock_id = ($row['stock_num'] != '') ? $row['stock_num'] : '';
		$cert_no = ($row['cert_num'] != '') ? $row['cert_num'] : '';
		$certificateLink = ($row['cert_url'] != '') ? $row['cert_url'] : '';
		$diamond_image = ($row["image_thumb_url"] != '') ? $row["image_thumb_url"] : '';
		$diamond_video = ($row['video_url'] != '') ? $row['video_url'] : '';
		$diamond_type = ($row['diamond_type'] != '') ? $row['diamond_type'] : '';;
		$weight = ($row['size'] != '') ? $row['size'] : '';
		$table_d = ($row['table_percent'] != '') ? $row['table_percent'] : '';
		$depth = ($row['depth_percent'] != '') ? $row['depth_percent'] : '';
		$measurements = ($row['measurement'] != '') ? $row['measurement'] : '';
		$m_length = ($row['meas_length'] != '') ? $row['meas_length'] : '';
		$m_width = ($row['meas_width'] != '') ? $row['meas_width'] : '';
		$m_height = ($row['meas_depth'] != '') ? $row['meas_depth'] : '';
		$ratio = ($row['meas_ratio'] != '') ? $row['meas_ratio'] : '';
		$country = ($row['country'] != '') ? $row['country'] : '';
		$city = ($row['city'] != '') ? $row['city'] : '';
		$state = ($row['state'] != '') ? $row['state'] : '';
		
		$availability = ($row['available'] != '') ? $row['available'] : '';
		$milky = ($row['milky'] != '') ? $row['milky'] : '';
		$shade = ($row['shade'] != '') ? $row['shade'] : '';
		$crown_angle = ($row['crown_angle'] != '') ? $row['crown_angle'] : '';
		$crown_ht = ($row['crown_height'] != '') ? $row['crown_height'] : '';
		$pavillion_angle = ($row['pavilion_angle'] != '') ? $row['pavilion_angle'] : '';
		$pavillion_depth = ($row['pavilion_depth'] != '') ? $row['pavilion_depth'] : '';
		$girdle_perct = ($row['girdle_percent'] != '') ? $row['girdle_percent'] : '';
		$girdle_con = ($row['girdle_condition'] != '') ? $row['girdle_condition'] : '';
		$culet_condition = ($row['culet_condition'] != '') ? $row['culet_condition'] : '';

		
		$girdle_thin = ($row['girdle_min'] != '') ? $row['girdle_min'] : '';
		$girdle_thick = ($row['girdle_max'] != '') ? $row['girdle_max'] : '';
		$culet_size = ($row['culet_size'] != '') ? $row['culet_size'] : '';
		$keytosymb = ($row['key_to_symbol'] != '') ? $row['key_to_symbol'] : '';
		$eye_clean = ($row['eye_clean'] != '') ? $row['eye_clean'] : '';
		$treatment = ($row['treatment'] != '') ? $row['treatment'] : '';
		$member_comment = ($row['comments'] != '') ? $row['comments'] : '';

		if(!empty($row['total_sales_price'])){
			// $main_price = $row['total_sales_price'] * 1.50;
			$total_sales_price = floatval($row['total_sales_price']);
			// $discount_percentage = 30; // Discount percentage
			// $discounted_price = $total_sales_price - ($total_sales_price * $discount_percentage / 100);
			
			$main_price = round($total_sales_price, 0);
		}else{
			$main_price = 0;
		}
		$cash_price = ($main_price != '') ? $main_price : 0;
		$Buy_Price = ($main_price != '') ? $main_price : 0;
		$shape = ($row['shape'] != '') ? ucfirst(strtolower($row['shape'])) : 'None';
		$color = ($row['color'] != '') ? $row['color'] : 'None';
		$is_fancy = ($row['is_fancy'] != '') ? $row['is_fancy'] : '0';	
		$fancy_color = ($row['fancy_color_dominant_color'] != '') ? $row['fancy_color_dominant_color'] : '';
		$fancy_color_overtone = ($row['fancy_color_overtone'] != '') ? $row['fancy_color_overtone'] : '';
		$fancy_color_intensity = ($row['fancy_color_intensity'] != '') ? $row['fancy_color_intensity'] : '';
		$clarity = ($row['clarity'] != '') ? $row['clarity'] : 'None';
		
		// $cut = ($row['cut'] != '') ? $row['cut'] : '';
		if($row['cut'] == 'Excellent'){
			$cuts = 'EX';
		}else if($row['cut'] == 'Ideal'){
			$cuts = 'ID';
		}else if($row['cut'] = 'Very Good'){
			$cuts = 'VG';
		}else if($row['cut'] == 'Good'){
			$cuts = 'GD';
		}else if($row['cut'] != ''){
			$cuts = $row['cut'];
		}else{
			$cuts = 'None';
		}
		$cut = $cuts;



		// $polish = ($row['polish'] != '') ? $row['polish'] : '';
		if($row['polish'] == 'Excellent'){
			$pol = 'EX';
		}else if($row['polish'] == 'Ideal'){
			$pol = 'ID';
		}else if($row['polish'] = 'Very Good'){
			$pol = 'VG';
		}else if($row['polish'] == 'Good'){
			$pol = 'GD';
		}else if($row['polish'] != ''){
			$pol = $row['polish'];
		}else{
			$pol = 'None';
		}
		$polish = $pol;



		// $symmetry = ($row['symmetry'] != '') ? $row['symmetry'] : '';
		if($row['symmetry'] == 'Excellent'){
			$sym = 'EX';
		}else if($row['symmetry'] == 'Ideal'){
			$sym = 'ID';
		}else if($row['symmetry'] = 'Very Good'){
			$sym = 'VG';
		}else if($row['symmetry'] == 'Good'){
			$sym = 'GD';
		}else if($row['symmetry'] != ''){
			$sym = $row['symmetry'];
		}else{
			$sym = 'None';
		}
		$symmetry = $sym;


		$fluorescence = ($row['fluor_color'] != '') ? $row['fluor_color'] : 'None';
		$fluor_intensity = ($row['fluor_intensity'] != '') ? $row['fluor_intensity'] : 'None';
		
		$lab = ($row['lab'] != '') ? $row['lab'] : 'None';
		$BGM = ($row['bgm'] != '') ? $row['bgm'] : '';
		$cert_comment = ($row['cert_comment'] != '') ? $row['cert_comment'] : '';
		$country_of_origin = ($row['country_of_origin'] != '') ? $row['country_of_origin'] : '';
		$star_length = ($row['star_length'] != '') ? $row['star_length'] : '';
		$pair_stock_num = ($row['pair_stock_num'] != '') ? $row['pair_stock_num'] : '';
		$parcel_stones = ($row['parcel_stones'] != '') ? $row['parcel_stones'] : '';
		$inclusion_center = ($row['inclusion_center'] != '') ? $row['inclusion_center'] : '';
		$inclusion_black = ($row['inclusion_black'] != '') ? $row['inclusion_black'] : '';
		$brand = ($row['brand'] != '') ? $row['brand'] : '';
		$masked_video_url = ($row['masked_video_url'] != '') ? $row['masked_video_url'] : '';
		$rapnet_price = ($row['rapnet_price'] != '') ? $row['rapnet_price'] : '';
		$short_title = ($row['short_title'] != '') ? $row['short_title'] : '';

		$created_at = ($row['created_at'] != '') ? $row['created_at'] : '';
		$updated_at = ($row['updated_at'] != '') ? $row['updated_at'] : '';

		// $vendor_name = ($row['vendor_name'] != '') ? $row['vendor_name'] : '';
		$vendor_name = ($row['vendor_name'] != '') ? str_replace('🔹', '', $row['vendor_name']) : '';
		// $vendor_name = 'error';
		
		
		$description = '<ul>';
			$description .= ($shape != '') ? '<li><strong>SHAPE</strong> '.$shape.'</li>' : '';
			$description .= ($weight != '') ? '<li><strong>CARAT</strong> '.$weight.'ct.</li>' : '';
			$description .= ($color != '') ? '<li><strong>COLOR</strong> '.$color.'</li>' : '';
			$description .= ($clarity != '') ? '<li><strong>CLARITY</strong> '.$clarity.'</li>' : '';
			$description .= ($cut != '') ? '<li><strong>CUT</strong> '.$cut.'</li>' : '';
			
			$description .= ($lab != '') ? '<li><strong>REPORT</strong> '.$lab.'</li>' : '';
			$description .= ($cert_no != '') ? '<li><strong>CERTIFICATE NO</strong> <a target="_blank" href="'.$certificateLink.'">'.$cert_no.'</a></li>' : '';
			$description .= ($m_length != '') ? '<li><strong>LENGTH</strong> '.$m_length.' mm</li>' : '';
			$description .= ($m_width != '') ? '<li><strong>WIDTH</strong> '.$m_width.' mm</li>' : '';
			$description .= ($m_height != '') ? '<li><strong>DEPTH</strong> '.$m_height.' mm</li>' : '';

			$description .= ($table_d != '') ? '<li><strong>TABLE (%)</strong> '.$table_d.' %</li>' : '';
			$description .= ($depth != '') ? '<li><strong>DEPTH (%)</strong> '.$depth.' %</li>' : '';
			$description .= ($symmetry != '') ? '<li><strong>SYMMETRY</strong> '.$symmetry.'</li>' : '';
			$description .= ($polish != '') ? '<li><strong>POLISH</strong> '.$polish.'</li>' : '';
			$description .= ($fluorescence != '') ? '<li><strong>FLUORESCENCE</strong> '.$fluorescence.'</li>' : '';
			$description .= ($measurements != '') ? '<li><strong>MEASUREMENTS</strong> '.$measurements.'</li>' : '';
			$description .= ($ratio != '') ? '<li><strong>RATIO</strong> '.$ratio.'</li>' : '';
		$description .= '</ul>';


		$data = [

			'stock_id' => $stock_id,

			'short_title' => $short_title,

			'is_fancy' => $is_fancy,

			'm_length' => $m_length,

			'm_width' => $m_width,

			'm_depth' => $m_height,

			'availability' => $availability,

			'shape' => $shape,

			'weight' => $weight,

			'color' => $color,

			'clarity' => $clarity,

			'cut_grade' => $cut,

			'polish' => $polish,

			'symmetry' => $symmetry,

			'fluorescence_int' => $fluor_intensity,

			'fluorescence_color' => $fluorescence,

			'measurements' => $measurements,

			'lab' => $lab,

			'treatment' => $treatment,

			'fancy_color' => $fancy_color,

			'fancy_color_intensity' => $fancy_color_intensity,

			'fancy_color_overtone' => $fancy_color_overtone,

			'depth' => $depth,

			'table_d' => $table_d,

			'girdle_thin' => $girdle_thin,

			'girdle_thick' => $girdle_thick,

			'girdle_perct' => $girdle_perct,

			'girdle_con' => $girdle_con,

			'culet_size' => $culet_size,

			'culet_con' => $culet_condition,

			'crown_ht' => $crown_ht,

			'crown_angle' => $crown_angle,

			'pavillion_depth' => $pavillion_depth,

			'pavillion_angle' => $pavillion_angle,

			'cert_comments' => $cert_comment,

			'country' => $country,

			'state' => $state,

			'city' => $city,

			'origin' => $country_of_origin,

			'keytosymb' => $keytosymb,

			'shade' => $shade,

			'star_len' => $star_length,

			'report_dt' => '',

			'report_type' => '',

			'milky' => $milky,

			'eye_clean' => $eye_clean,

			'gemprint_ID' => '',

			'BGM' => $BGM,

			'ratio' => $ratio,

			'diamond_type' => $diamond_type,

			'member_comment' => $member_comment,

			'time_to_location' => '',

			'LsMatchedPairSeparable' => '',

			'pair_stock' => $pair_stock_num,

			'allow_raplink_feed' => '',

			'parcel_stones' => $parcel_stones,

			'center_inclusion' => $inclusion_center,

			'black_inclusion' => $inclusion_black,

			'lab_location' => '',

			'brand' => $brand,

			'Sarine_Name' => '',

			'Internal_Clarity_Desc_Code' => '',

			'Clarity_Description' => '',

			'Modified_Rate' => '',

			'wire_discount_price' => '',

			'diamond_image' => $diamond_image,

			'diamond_video' => $diamond_video,

			'Video_HTML' => $masked_video_url,

			'CertificateLink' => $certificateLink,

			'Rap_Price' => $rapnet_price,

			'Memo_Price' => '',

			'Memo_Discount_PER' => '',

			'Buy_Price' => $Buy_Price,

			'Buy_Price_Discount_PER' => '',

			'COD_Buy_Price' => '',

			'COD_Buy_Price_Discount_PER' => '',

			'Certificate' => $cert_no,

			'grade' => $cut,

			'cut' => $cut,

			'cash_price' => $cash_price,

			'report_filename' => '',

			'rapnet' => '',

			'created_at' => $created_at,

			'edited_at' => $updated_at,

			'description' => $description,

			'vendor_id' => $vendor_id,

			'vendor_name' => $vendor_name,

			'feed_type'=> 'API'

		];
		return $data;
	}

	private function insertDiamondRecord($diamondData, $stock_No, $vendor_id, $vendor_name) {
			// Insert into the 'tbl_vdb_diamond' table
			DB::table('tbl_vdb_diamond')->insert($diamondData);
			// Insert into the 'tbl_vdb_diamond_insert_update' table
			DB::table('tbl_vdb_diamond_insert_update')->insert([
				'stock_id' => $stock_No,
				'vendor_id' => $vendor_id,
				'vendor_name' => $vendor_name,
				'feed_type' => 'API'
			]);
	}

	private function updateDiamondRecord($diamondData, $stock_No, $vendor_id) {
			// Update the 'tbl_vdb_diamond' table
			DB::table('tbl_vdb_diamond')
				->where([
					'stock_id' => $stock_No,
					'vendor_id' => $vendor_id,
					'feed_type' => 'API',
				])
				->update($diamondData);
		
			// Update the 'tbl_vdb_diamond_insert_update' table
			DB::table('tbl_vdb_diamond_insert_update')
				->where([
					'stock_id' => $stock_No,
					'vendor_id' => $vendor_id,
					'feed_type' => 'API',
				])
				->update(['is_update' => 1]);
	}
		
	private function markDiamondAsDeleted($stock_id) {
			DB::table('tbl_vdb_diamond_insert_update')
				->where([
					'stock_id' => $stock_id,
					'feed_type' => 'API',
				])
				->update(['is_delete' => 1]);
	}

	private function truncateDiamondTables() {
		// Truncate the 'tbl_vdb_diamond' table
		DB::table('tbl_vdb_diamond')->truncate();
	
		// Truncate the 'tbl_vdb_diamond_insert_update' table
		DB::table('tbl_vdb_diamond_insert_update')->truncate();
	}
	
		
	function print_pre($data)
	{ 
		   echo "<pre>";print_r($data);echo "</pre>";       
	}
	   
	function print_ex($data)
	{ 
		   echo "<pre>";print_r($data);echo "</pre>";exit();       
	}
		
	
	function demogetVdbDiamonds() {
		// die("fdf");
		$records = array();
	
		// for ($page = 1; $page <= 2; $page++) {
			// for ($page = 1; $page <= 2400; $page++) {
				$page = 1;
			$curl = curl_init();
	
			curl_setopt_array($curl, array(
				CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds?type=Lab_grown_Diamond&page_number=' . $page . '&page_size=50&stock_num=NGT-09-26',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'GET',
				CURLOPT_HTTPHEADER => array(
					'Authorization: Token token=4ujQnUscjOG_BWpCXwBTBqwTtYzHkQ_RUvkPtNJBGXo, api_key=_j1wfVmJTpz1noOAU_9aVlA'
				),
			));
	
			$response = curl_exec($curl);
			curl_close($curl);
	
			$data = json_decode($response, true);
			
			if (isset($data['response']['body']['diamonds'])) {
				$diamonds = $data['response']['body']['diamonds'];
				$records = array_merge($records, $diamonds);	
			}
		// }
		$this->print_ex($data); die;
		// print_r($data);
		// return $records;
	}

	function bulkPrepareVdbDiamonds() {
		// die("fdf");
		$records = array();
	
		// for ($page = 1; $page <= 2; $page++) {
			// for ($page = 1; $page <= 2400; $page++) {
				$page = 1;
			$curl = curl_init();
	
			curl_setopt_array($curl, array(
				CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds/inventory?type=Lab_grown_Diamond&upload_file_type=0',
				// CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds?type=Lab_grown_Diamond&upload_file_type=1',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'GET',
				CURLOPT_HTTPHEADER => array(
					'Authorization: Token token=4ujQnUscjOG_BWpCXwBTBqwTtYzHkQ_RUvkPtNJBGXo, api_key=_j1wfVmJTpz1noOAU_9aVlA'
				),
			));
	
			$response = curl_exec($curl);
			curl_close($curl);
	
			$data = json_decode($response, true);
			
			// if (isset($data['response']['body']['diamonds'])) {
			// 	$diamonds = $data['response']['body']['diamonds'];
			// 	$records = array_merge($records, $diamonds);	
			// }

		// }
		$this->print_ex($data); die;
		// print_r($data);
		// return $records;
	}

	function bulkGetVdbDiamonds() {
		// die("fdf");
		$records = array();
	
		// for ($page = 1; $page <= 2; $page++) {
			// for ($page = 1; $page <= 2400; $page++) {
				$page = 1;
			$curl = curl_init();
	
			curl_setopt_array($curl, array(
				CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds/inventory_url?type=Lab_grown_Diamond&file_type=0&with_images=true',
				// CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds/inventory?type=Lab_grown_Diamond&upload_file_type=1',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'GET',
				CURLOPT_HTTPHEADER => array(
					'Authorization: Token token=4ujQnUscjOG_BWpCXwBTBqwTtYzHkQ_RUvkPtNJBGXo, api_key=_j1wfVmJTpz1noOAU_9aVlA'
				),
			));
	
			$response = curl_exec($curl);
			curl_close($curl);
	
			$data = json_decode($response, true);
			
			
			// if (isset($data['response']['body']['diamonds'])) {
			// 	$diamonds = $data['response']['body']['diamonds'];
			// 	$records = array_merge($records, $diamonds);	
			// }

		// }
		$this->print_ex($data); die;
		// print_r($data);
		// return $records;
	}

	function prepare_for_bulk_download() {
		$records = array();
	
		$total_record = 0;
		$total_update = 0;
		$total_insert = 0;
		$total_delete = 0;
		// $vendor_id = 123;

		$curl = curl_init();
		
		curl_setopt_array($curl, array(
			CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds/inventory?type=Lab_grown_Diamond&upload_file_type=0',
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_ENCODING => '',
			CURLOPT_MAXREDIRS => 10,
			CURLOPT_TIMEOUT => 0,
			CURLOPT_FOLLOWLOCATION => true,
			CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			CURLOPT_CUSTOMREQUEST => 'GET',
			CURLOPT_HTTPHEADER => array(
				'Authorization: Token token=4ujQnUscjOG_BWpCXwBTBqwTtYzHkQ_RUvkPtNJBGXo, api_key=_j1wfVmJTpz1noOAU_9aVlA'
			),
		));

		$prepare_response = curl_exec($curl);
		curl_close($curl);
		$prepare_inventory = json_decode($prepare_response, true);
		$prepare_inventory_status = $prepare_inventory['response']['header']['status'];
		
		if(empty($prepare_inventory_status != 200)){

		$total_files_found = 1; 
		for ($i = 1; $i <= $total_files_found; $i++) {

			if($i == 5){
				break;
				die;
			}

			$curl = curl_init();
		
			curl_setopt_array($curl, array(
				CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds/inventory_url?type=Lab_grown_Diamond&file_type=0&file_number=1&with_images=true',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'GET',
				CURLOPT_HTTPHEADER => array(
					'Authorization: Token token=4ujQnUscjOG_BWpCXwBTBqwTtYzHkQ_RUvkPtNJBGXo, api_key=_j1wfVmJTpz1noOAU_9aVlA'
				),
			));

			$responses = curl_exec($curl);
			curl_close($curl);
			$data_length = json_decode($responses, true);
			// $this->print_ex($data_length); die;

			// $total_files_found = floor($data_length['response']['total_files_found']);
			$lab_grown_diamond_inventory_url = $data_length['response']['lab_grown_diamond_inventory_url'];

			// ---
				// $client = new Client();
				// $response = $client->get($lab_grown_diamond_inventory_url);
				// $jsonData = $response->getBody()->getContents();
				
				// // Decode JSON data
				// $data = json_decode($jsonData, true);
				
				// // Print or process the data
				// $this->print_ex($data);
			// ---

			// Create a Guzzle client
			$client = new Client();
			$url = $lab_grown_diamond_inventory_url;

			// Path to save the file in Laravel's storage directory
			$localFile = storage_path('app/public/file_'.$i.'.json');

			// Ensure the public directory exists
			if (!file_exists(dirname($localFile))) {
				mkdir(dirname($localFile), 0755, true);
			}

			// Save the file
			$client->get($url, ['sink' => $localFile]);

			// echo "File saved successfully to: " . $localFile;

			$jsonPath = storage_path('app/public/file_1.json'); // File path
			if (file_exists($jsonPath)) {
				// Read the JSON file
				$jsonData = file_get_contents($jsonPath);
				$data = json_decode($jsonData, true); // Convert JSON to PHP array
				print_r($data);
			} else {
				die("File not found at: $jsonPath");
			}



		}
		die;
			// $this->print_ex($data); die;

			$query = "select stock_id from tbl_vdb_diamond limit 150000"; 
			$records = DB::select($query);
			$existingStockIds = array_column($records, 'stock_id');
			// $this->print_ex($records); die;
			// for ($page = 1; $page <= $total_diamonds_found; $page++) {
				for ($page = 1; $page <= 1; $page++) {
				// echo "heloo";
				// break;
				

				$curl = curl_init();
		
				curl_setopt_array($curl, array(
					CURLOPT_URL => 'https://apiservices.vdbapp.com/v2/diamonds?type=Lab_grown_Diamond&page_number=' . $page . '&page_size=50&with_images=true&updated_at='.$filter_date,
					CURLOPT_RETURNTRANSFER => true,
					CURLOPT_ENCODING => '',
					CURLOPT_MAXREDIRS => 10,
					CURLOPT_TIMEOUT => 0,
					CURLOPT_FOLLOWLOCATION => true,
					CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
					CURLOPT_CUSTOMREQUEST => 'GET',
					CURLOPT_HTTPHEADER => array(
						'Authorization: Token token=4ujQnUscjOG_BWpCXwBTBqwTtYzHkQ_RUvkPtNJBGXo, api_key=_j1wfVmJTpz1noOAU_9aVlA'
					),
				));
		
				$response = curl_exec($curl);
				curl_close($curl);
		
				$data = json_decode($response, true);
				
				if (isset($data['response']['body']['diamonds'])) {

					$diamondRecord = $data['response']['body']['diamonds'];
					foreach ($diamondRecord as $row) {

						$vendor_id = $row['vendor_id'];
						// $vendor_name = $row['vendor_name'];
						$vendor_name = ($row['vendor_name'] != '') ? str_replace('🔹', '', $row['vendor_name']) : 'dummy';
						$stock_No = $row['stock_num'];

						$diamondData = $this->vdbDiamond($row, $vendor_id);

						if (in_array($stock_No, $existingStockIds)) {

							$existingStockIds = array_diff($existingStockIds, [$stock_No]);

							// $single_query = "select * from tbl_vdb_diamond where stock_id = '$stock_No' and vendor_id = '$vendor_id' limit 1"; 
							$single_query = "select vendor_id, created_at, edited_at from tbl_vdb_diamond where stock_id = '$stock_No' and vendor_id = '$vendor_id' limit 1"; 
							$record = DB::select($single_query);

							if($record[0]->vendor_id == $diamondData['vendor_id'] && $record[0]->created_at != $diamondData['created_at'] || $record[0]->edited_at != $diamondData['edited_at']){
								$this->updateDiamondRecord($diamondData, $stock_No, $vendor_id);
								$total_update++;
							}

						}else{

							$this->insertDiamondRecord($diamondData, $stock_No, $vendor_id, $vendor_name);
							$total_insert++;

						}
						
						$total_record++;

					}
					
				}
			}

			// Mark remaining stocks as deleted
			foreach ($existingStockIds as $stock_id) {
				$this->markDiamondAsDeleted($stock_id);
				$total_delete++;
			}

			$log_data = [
				'total_record' => $total_record,
				'total_update' => $total_update,
				'total_insert' => $total_insert,
				'total_delete' => $total_delete,
				'file' => 'VDB Diamonds',
				'log_time' => now(), // Use Laravel's helper for the current timestamp
				'type' => 'Lab Grown',
				'vendor_id' => $vendor_id,
			];
			
			// Insert the log data into the database
			DB::table('tbl_vdb_inventory_log')->insert($log_data);

		}
	}

	// ---
	function updateDeleteShopify(){
		$deleteQuery = "SELECT c.stock_id,c.product_id,c.vendor_id FROM `tbl_cart` c LEFT JOIN `tbl_vdb_diamond` d ON c.`stock_id` = d.`stock_id` WHERE d.`stock_id` IS NULL"; 
		$deleteRecords = DB::select($deleteQuery);
		// $this->print_ex($deleteRecords);
		$shop_name = '12cd8f-f4.myshopify.com';
		if(!empty($deleteRecords)){
			// $deleteStatus = $this->getOrders($shop_name);
			// $this->print_ex($deleteRecords);
			foreach($deleteRecords as $row){
				// $this->print_pre($row);
				$product_id = $row->product_id;
				$stock_id = $row->stock_id;
				$deleteStatus = $this->deleteProduct($product_id,$shop_name);
				// $this->print_ex($deleteStatus);
				if($deleteStatus['status'] == 'true'){

					date_default_timezone_set('Asia/Kolkata');
					$current_dt = date('Y-m-d h:i A');
					
					$tbl_inventory_data = [
						'stock_id' => $row->stock_id,
						'vendor_id' => $row->vendor_id,
						'product_id' => $row->product_id,
						'insert_update_delete' => "delete",
						'date_time' => $current_dt,
					];
					DB::table('tbl_inventory')->insert($tbl_inventory_data);

					DB::table('tbl_cart')->where(['stock_id' => $stock_id, 'product_id' => $product_id])->delete();
				}
			}
		}else{
			// $updateQuery = "SELECT c.stock_id, c.product_id, d.diamond_image, d.shape, d.vendor_id, d.vendor_name, d.Buy_Price, d.weight, d.is_fancy, d.description, d.short_title, d.availability, d.color, d.clarity, d.cut, d.polish, d.symmetry, d.fluorescence_int, d.fluorescence_color, d.diamond_video, d.CertificateLink, d.Certificate, d.measurements, d.lab, d.depth, d.table_d, d.culet_size, d.crown_angle, d.crown_ht, d.pavillion_angle, d.pavillion_depth, d.star_len, d.member_comment, d.country, d.state, d.city, d.ratio, d.Video_HTML, d.rapnet, d.growth_type FROM `tbl_cart` c INNER JOIN `tbl_vdb_diamond` d ON c.`stock_id` = d.`stock_id`"; 

			$updateQuery = "SELECT c.stock_id, c.product_id, d.diamond_image, d.shape, d.vendor_id, d.vendor_name, d.Buy_Price, d.weight, d.is_fancy, d.description, d.short_title, d.availability, d.color, d.clarity, d.cut, d.polish, d.symmetry, d.fluorescence_int, d.fluorescence_color, d.diamond_video, d.CertificateLink, d.Certificate, d.measurements, d.lab, d.depth, d.table_d, d.culet_size, d.crown_angle, d.crown_ht, d.pavillion_angle, d.pavillion_depth, d.star_len, d.member_comment, d.country, d.state, d.city, d.ratio, d.Video_HTML, d.rapnet, d.growth_type FROM `tbl_cart` c INNER JOIN `tbl_vdb_diamond` d ON c.`stock_id` = d.`stock_id` WHERE c.shopify_update = 0 LIMIT 500"; 
			$record = DB::select($updateQuery);
		
			$this->print_ex($record);
			if(!empty($record)){
        
				$updateLocal = [];
				if (!empty($record)) {
			
				  foreach ($record as $row) {
					// $row->product_id = $cart_record[0]->product_id;
					$stock_id = $row->stock_id;
					$vendor_id = $row->vendor_id;

					if(!empty($row->diamond_image)){
					  $diamond_img = $row->diamond_image;
					  $alt = $row->shape;
					}else{
					  $diamond_img = asset('assets/no_image.jpg');
					  $alt = "No image";	
					}
	  
					$vendor = $row->vendor_name." ".$row->vendor_id;
					$row->Buy_Price = $row->Buy_Price;
					
	
					$row->title = $row->weight . " Carat " . $row->shape ." ". $row->color ." ". $row->clarity . " Lab Diamond ";
			
					$variants = [
			
					  'sku' => $row->stock_id,

					  'price' => $row->Buy_Price,
			
					  'cost' => $row->Buy_Price,
			
					  'inventory_quantity' => 1,
			
					  'taxable' => true,
			
					  'requires_shipping' => true,
			
					  'fulfillment_service' => 'manual',
			
					  'inventory_policy' => 'deny',
			
					  'inventory_management' => 'shopify'
			
					];

					// -------------

					// -------------------
			  
					$is_fancy = ($row->is_fancy == 1) ? 'fancy' : 'not_fancy';

					$dataSend = [
			
					  'product' => [
			
						'id' => $row->product_id,
			
						'title' => $row->title,
			
						'body_html' => $row->description,
			
						'product_type' => 'lab_grown_diamonds',
			
						'handle' => $row->stock_id,
			
						'status' => 'active',
			
						'vendor' => $vendor,
	  
						'published_scope' => 'pos',

						'tags' => $is_fancy,

						'variants' => [
			
						  $variants
			
						],
			
						'images' => [
			
						  [
			
							"position" => 1,
			
							"alt" => $alt,
			
							"src" => $diamond_img 
			
						  ]
			
						]
			
					  ]
			
					];
	  
	  
					$updatedRecord = $this->updateDiamonds(json_encode($dataSend), $row->product_id, $shop_name);
					// $this->print_ex($updatedRecord);
					// die;
			
					if(empty($updatedRecord->product)){
					  $response_data = [
						'records'=> [],
						'message'=> 'successfully update',
						'status'=> 'true'
					  ];
					  return response()->json($response_data)
										->header('Access-Control-Allow-Origin', '*')
										->header('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE, OPTIONS')
										->header('Access-Control-Allow-Headers', 'Content-Type, Authorization');
					}
			
					$newRecord = $this->updateMetafield($row, $row->product_id, $shop_name);
			
					$update_query = "UPDATE tbl_cart 
						SET shopify_update = 1 
						WHERE stock_id = '$stock_id' AND vendor_id = '$vendor_id' 
						LIMIT 1";

					$updated_rows = DB::update($update_query);  

	
					date_default_timezone_set('Asia/Kolkata');
					$current_dt = date('Y-m-d h:i A');
					
					$tbl_inventory_data = [
						'stock_id' => $row->stock_id,
						'vendor_id' => $row->vendor_id,
						'product_id' => $row->product_id,
						'insert_update_delete' => "update",
						'date_time' => $current_dt,
					];
					
					DB::table('tbl_inventory')->insert($tbl_inventory_data);
					
			
				  }
			
				}

			}
		}
	}

	function deleteProduct($productId, $shop_name)
	{
		if (empty($productId)) {
			return ['error' => 'Product ID is required', 'status' => 'false'];
		}
	
		$shop_url = 'https://' . $shop_name . '/admin/api/2024-10/products/' . $productId . '.json'; // Shopify product endpoint
		$accessToken = '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'; // Replace with your access token
	
		$client = new Client([
			'base_uri' => $shop_url,
		]);
	
		$headers = [
			'Content-Type' => 'application/json',
			'X-Shopify-Access-Token' => $accessToken,
		];
	
		try {
			$response = $client->request('DELETE', $shop_url, [
				'headers' => $headers,
			]);
	
			if ($response->getStatusCode() === 200) {
				return ['success' => 'Product deleted successfully', 'status' => 'true'];
			} else {
				return ['error' => 'Failed to delete product', 'status' => 'false'];
			}
		} catch (\Exception $e) {
			return ['error' => $e->getMessage(), 'status' => 'false'];
		}
	}
	
	private function updateDiamonds($jsonBody, $productId,$shop_name) {
		if (empty($jsonBody) || empty($productId)) {
		  return [];
		}
	  
		$shop_url = 'https://'.$shop_name.'/admin/api/2024-10/products.json'; // Replace with your Shopify store URL
		$accessToken = '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'; // Replace with your access token
  
		$client = new Client([
		  'base_uri' => $shop_url
		]);
	  
		$headers = [
		  'Content-Type' => 'application/json',
		  'X-Shopify-Access-Token' => $accessToken
		];
	  
		$endpoint = "products/{$productId}.json";
		$maxRetries = 5;
		$retryDelay = 1; // Start with 1 second
	  
		for ($attempt = 0; $attempt < $maxRetries; $attempt++) {
		  try {
			$response = $client->request('PUT', $endpoint, [
			  "headers" => $headers,
			  "body" => $jsonBody
			]);
	  
			if ($response->getStatusCode() < 300) {
			  $body = $response->getBody();
			  return json_decode($body);
			} else {
			  throw new \Exception('Non-successful response');
			}
		  } catch (\GuzzleHttp\Exception\ClientException $e) {
			if ($e->getCode() == 429 && $attempt < $maxRetries - 1) {
			  sleep($retryDelay);
			  $retryDelay *= 2; // Exponential backoff
			} else {
			  error_log('API request failed: ' . $e->getMessage());
			  return [];
			}
		  }
		}
	  
		return [];
	}

  
	private function updateMetafield($jsonBody, $product_id, $shop_name) {
		// $this->print_ex($jsonBody);
		if (empty($jsonBody)) {
			return ['status' => 'error', 'message' => 'Empty input data'];
		}
	
		$shopUrl = 'https://' . $shop_name;
		$accessToken = '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'; // Replace with your access token
		$metafieldsUrl = "$shopUrl/admin/api/2024-10/products/$product_id/metafields.json";
		
		$client = new \GuzzleHttp\Client();
	
		// Fetch existing metafields
		try {
			$response = $client->request('GET', $metafieldsUrl, [
				'headers' => [
					'X-Shopify-Access-Token' => $accessToken,
					'Content-Type' => 'application/json',
				]
			]);
			
			$product_metafields = json_decode($response->getBody()->getContents(), true);
			// $this->print_ex($product_metafields);
			if (!isset($product_metafields['metafields'])) {
				throw new Exception('Failed to retrieve metafields');
			}
	
		} catch (Exception $e) {
			error_log('Exception fetching metafields: ' . $e->getMessage());
			return ['status' => 'error', 'message' => $e->getMessage()];
		}
	
		// New metafield entries
		// $metafields = [
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'stock_id',
		// 		'value' => $jsonBody->stock_id,
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'title',
		// 		'value' => $jsonBody->title,
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 	  'namespace' => 'Diamond',
		// 	  'key' => 'short_title',
		// 	  'value' => !empty($jsonBody->short_title) ? $jsonBody->short_title : 'Default Title',
		// 	  'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'availability',
		// 		'value' => !empty($jsonBody->availability) ? $jsonBody->availability : 'None',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'shape',
		// 		'value' => !empty($jsonBody->shape) ? $jsonBody->shape : 'Other',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'weight',
		// 		'value' => $jsonBody->weight,
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'color',
		// 		'value' => !empty($jsonBody->color) ? $jsonBody->color : 'None',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'clarity',
		// 		'value' => !empty($jsonBody->clarity) ? $jsonBody->clarity : 'None',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'cut',
		// 		'value' => !empty($jsonBody->cut) ? $jsonBody->cut : 'None',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'polish',
		// 		'value' => !empty($jsonBody->polish) ? $jsonBody->polish : 'None',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'symmetry',
		// 		'value' => !empty($jsonBody->symmetry) ? $jsonBody->symmetry : 'None',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'fluor',
		// 		'value' => !empty($jsonBody->fluorescence_int) ? $jsonBody->fluorescence_int : 'None',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 		'namespace' => 'Diamond',
		// 		'key' => 'Fluorescence_Color',
		// 		'value' => !empty($jsonBody->fluorescence_color) ? $jsonBody->fluorescence_color : 'None',
		// 		'type' => 'single_line_text_field',
		// 	],
		// 	[
		// 	  'namespace' => 'Diamond',
		// 	  'key' => 'VideoLink',
		// 	  'value' => !empty($jsonBody->diamond_video) ? $jsonBody->diamond_video : 'None',
		// 	  'type' => 'single_line_text_field',
		// 	],
		// 	// Add more fields as necessary
		// ];

		$metafields = [
			[
			  'namespace' => "Diamond",
			  'key' => "stock_id",
			  'value' => $jsonBody->stock_id,
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "title",
			  'value' => $jsonBody->title,
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "availability",
			  'value' => !empty($jsonBody->availability) ? $jsonBody->availability : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "shape",
			  'value' => !empty($jsonBody->shape) ? $jsonBody->shape : 'Other',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "weight",
			  'value' => (!empty($jsonBody->weight)) ? $jsonBody->weight : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "color",
			  'value' => !empty($jsonBody->color) ? $jsonBody->color : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "clarity",
			  'value' => !empty($jsonBody->clarity) ? $jsonBody->clarity : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "cut",
			  'value' => !empty($jsonBody->cut) ? $jsonBody->cut : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "polish",
			  'value' => !empty($jsonBody->polish) ? $jsonBody->polish : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "symmetry",
			  'value' => !empty($jsonBody->symmetry) ? $jsonBody->symmetry : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "fluor",
			  'value' => !empty($jsonBody->fluorescence_int) ? $jsonBody->fluorescence_int : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "Fluorescence_Color",
			  'value' => !empty($jsonBody->fluorescence_color) ? $jsonBody->fluorescence_color : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "measurements",
			  'value' => !empty($jsonBody->measurements) ? $jsonBody->measurements : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "lab",
			  'value' => !empty($jsonBody->lab) ? $jsonBody->lab : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "depth",
			  'value' => !empty($jsonBody->depth) ? $jsonBody->depth : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "table_d",
			  'value' => !empty($jsonBody->table_d) ? $jsonBody->table_d : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "culet_size",
			  'value' => (!empty($jsonBody->culet_size)) ? $jsonBody->culet_size : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "crown_angle",
			  'value' => (!empty($jsonBody->crown_angle)) ? $jsonBody->crown_angle : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "crown_ht",
			  'value' => (!empty($jsonBody->crown_ht)) ? $jsonBody->crown_ht : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "pavillion_angle",
			  'value' => (!empty($jsonBody->pavillion_angle)) ? $jsonBody->pavillion_angle : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "pavillion_depth",
			  'value' => (!empty($jsonBody->pavillion_depth)) ? $jsonBody->pavillion_depth : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "star_len",
			  'value' => (!empty($jsonBody->star_len)) ? $jsonBody->star_len : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "Member_Comments",
			  'value' => (!empty($jsonBody->member_comment)) ? $jsonBody->member_comment : 'None',
			  'type' => "multi_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "country",
			  'value' => (!empty($jsonBody->country)) ? $jsonBody->country : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "state",
			  'value' => (!empty($jsonBody->state)) ? $jsonBody->state : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "city",
			  'value' => (!empty($jsonBody->city)) ? $jsonBody->city : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "price",
			  'value' => (!empty($jsonBody->Buy_Price)) ? $jsonBody->Buy_Price : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "ratio",
			  'value' => (!empty($jsonBody->ratio)) ? $jsonBody->ratio : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "ImageLink",
			  'value' => (!empty($jsonBody->diamond_image)) ? $jsonBody->diamond_image : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "VideoLink",
			  'value' => (!empty($jsonBody->diamond_video)) ? $jsonBody->diamond_video : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "Video_HTML",
			  'value' => (!empty($jsonBody->Video_HTML)) ? $jsonBody->Video_HTML : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "CertificateLink",
			  'value' => (!empty($jsonBody->CertificateLink)) ? $jsonBody->CertificateLink : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "Rap_Price",
			  'value' => (!empty($jsonBody->rapnet)) ? $jsonBody->rapnet : "None",
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "growth_type",
			  'value' => (!empty($jsonBody->growth_type)) ? $jsonBody->growth_type : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "short_title",
			  'value' => (!empty($jsonBody->short_title)) ? $jsonBody->short_title : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "is_fancy",
			  'value' => (!empty($jsonBody->is_fancy)) ? $jsonBody->is_fancy : 1,
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "vendor_name",
			  'value' => (!empty($jsonBody->vendor_name)) ? $jsonBody->vendor_name : 'None',
			  'type' => "single_line_text_field",
			],
			[
			  'namespace' => "Diamond",
			  'key' => "vendor_id",
			  'value' => (!empty($jsonBody->vendor_id)) ? $jsonBody->vendor_id : "None",
			  'type' => "single_line_text_field",
			]

		];
	
		foreach ($metafields as $metafield) {
			$meta_id = null;
	
			// Check if the metafield already exists
			foreach ($product_metafields['metafields'] as $existingMetafield) {
				if ($existingMetafield['key'] === $metafield['key'] && $existingMetafield['namespace'] === 'Diamond') {
					$meta_id = $existingMetafield['id'];
					break;
				}
			}
	
			// Update or create metafield
			if ($meta_id) {
				// Update existing metafield
				$updateUrl = "$shopUrl/admin/api/2024-10/metafields/$meta_id.json";
				$data = [
					'metafield' => [
						'id' => $meta_id,
						'value' => $metafield['value'],
						'type' => $metafield['type'],
					]
				];
	
				try {
					$response = $client->request('PUT', $updateUrl, [
						'headers' => [
							'X-Shopify-Access-Token' => $accessToken,
							'Content-Type' => 'application/json',
						],
						'json' => $data
					]);
	
					if ($response->getStatusCode() >= 300) {
						throw new Exception('Error updating metafield: ' . $response->getBody()->getContents());
					}
	
				} catch (Exception $e) {
					error_log('Exception updating metafield: ' . $e->getMessage());
					return ['status' => 'error', 'message' => 'Failed to update metafield: ' . $metafield['key']];
				}
	
			} else {
				// Create new metafield
				$createUrl = "$shopUrl/admin/api/2024-10/products/$product_id/metafields.json";
				$data = [
					'metafield' => $metafield
				];
				
				// $this->print_ex($data);
	
				try {
					$response = $client->request('POST', $createUrl, [
						'headers' => [
							'X-Shopify-Access-Token' => $accessToken,
							'Content-Type' => 'application/json',
						],
						'json' => $data
					]);
	
					if ($response->getStatusCode() >= 300) {
						throw new Exception('Error creating metafield: ' . $response->getBody()->getContents());
					}
	
				} catch (Exception $e) {
					error_log('Exception creating metafield: ' . $e->getMessage());
					return ['status' => 'error', 'message' => 'Failed to create metafield: ' . $metafield['key']];
				}
			}
		}
	
		return ['status' => 'success', 'message' => 'Metafields updated or created successfully'];
	}
	// ---
	function getOrders($shop_name, $accessToken='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', $limit = 250, $status = 'any')
	{
		$shop_url = 'https://' . $shop_name . '/admin/api/2024-10/orders.json'; // Shopify orders endpoint

		$client = new Client([
			'base_uri' => $shop_url,
		]);

		$headers = [
			'Content-Type' => 'application/json',
			'X-Shopify-Access-Token' => $accessToken,
		];

		$queryParams = [
			'limit' => $limit,       // Number of orders to retrieve (max 250)
			'status' => $status,     // 'open', 'closed', or 'any'
		];

		try {
			$response = $client->request('GET', $shop_url, [
				'headers' => $headers,
				'query' => $queryParams,
			]);

			$body = $response->getBody();
			$parsedBody = json_decode($body, true);

			return $parsedBody['orders'] ?? []; // Return the list of orders
		} catch (\Exception $e) {
			return ['error' => $e->getMessage()];
		}
	}


}